// include.h
// this is the main include including

#define SNAP ((float)(3<<18)) // vertex snapping

// beemodel [triangle][vertex][axis]
float beemodel[10][3][3]= {
	{	{ 0.0f, -1.0f, 0.0f }, { 2.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 2.0f } }, // 1
	{	{ 0.0f, -1.0f, 0.0f }, { 0.0f, 0.0f, -2.0f }, { 2.0f, 0.0f, 0.0f } }, // 2
	{	{ 0.0f, -1.0f, 0.0f }, { -2.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, -2.0f } }, // 3
	{	{ 0.0f, -1.0f, 0.0f }, { 0.0f, 0.0f, 2.0f }, { -2.0f, 0.0f, 0.0f } }, // 4
	{	{ 0.0f, 4.0f, 0.0f }, { 0.0f, 0.0f, 2.0f }, { 2.0f, 0.0f, 0.0f } }, // 5
	{	{ 0.0f, 4.0f, 0.0f }, { 2.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, -2.0f } }, // 6
	{	{ 0.0f, 4.0f, 0.0f }, { 0.0f, 0.0f, -2.0f }, { -2.0f, 0.0f, 0.0f } }, // 7
	{	{ 0.0f, 4.0f, 0.0f }, { -2.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 2.0f } }, // 8
	{	{ 0.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 0.0f } }, // 9
	{	{ 0.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 0.0f } } // 10
};

int yr_d, xr_d, zr_d; // degrees of rotation
int i, j, a, b; // loop counters

int waspon;
float yr_r, xr_r, zr_r; // radians
float xpos, ypos, zpos; // location in space (for translation)
float DVec[4], SVec[4]; // temp store for point to be processed
float x_cos, x_sin;
float y_cos, y_sin;
float z_cos, z_sin; // temp for cos and sin calcs

GrVertex point[3], ppoint[3]; // transforming point and projected point

float wmatrix[4][4] ={ // the world transformation matrix
	{1.0f, 0.0f, 0.0f, 0.0f},
	{0.0f, 1.0f, 0.0f, 0.0f},
	{0.0f, 0.0f, 1.0f, 0.0f},
	{0.0f, 0.0f, 0.0f, 1.0f} };

// prototypes
void Animate (void);
void InitGraphics(void);
void CloseGraphics(void);
void xrotate (void);
void yrotate (void);
void zrotate (void);
void PresetTriangleInfo(void);
void GetTriangle(int);
void TransformPoint(int);
void DrawBee(void);
void DrawWasp(void);